/* ----------------------------------------------------------
%                        Copyright (C) 1998
%        Hiroshi Nakashima, Kazuhiko Ohno, Namiyo Sugiyama,
%        and Department of Information and Computer Sciences 
%                 Toyohashi University of Technology
%----------------------------------------------------------- */  

#define KTH_READ

/*
  The following #define should be commented out (or deleted) for final
  version 
*/
/*
#define KTH_DEBUG
*/

#ifdef  KTH_DEBUG
#define KTH_printf(A) printf A
#else
#define KTH_printf(A)
#endif

#define KTH_THREAD_TABLE_SIZE 32
#define KTH_STACK_MARGIN      32
#define KTH_STACK_SIZE        992

extern q *KTH_do_unify();

struct KTH_thread_table_entry {
  q* stack_top;
  q* stackp;
  q* slimit;
  int prev;
  int next;
};

#define KTH_declare_external \
extern Const struct predicate KTH_continue_thread_pred; \
extern Const struct predicate KTH_terminate_thread_pred

#define KTH_declare_local \
q* stackp = KTH_current_stackp; \
q* slimit = KTH_current_slimit

#define KTH_execute(label) \
{ \
  if (allocp < heaplimit && stackp < slimit) goto label; \
}

#define KTH_within_stack(s) \
    ((unsigned long)(s) - (unsigned long)heaptop >= \
     (unsigned long)real_heapbytesize) \

#define KTH_confirm_non_stack_var(x, h)\
{\
  if (isref(x) && KTH_within_stack(x)) {\
    if (x == *((q*)x)) {\
      *((q*)x) = h = makeref(&h);\
                      }\
    else {\
      h = *((q*)x);\
    }\
  }\
  else {\
    h = x;\
  }\
}

#define KTH_unify(x, y) \
{ allocp = KTH_do_unify(allocp, (x), (y)); }

#define KTH_interrupt_goal() \
{ \
    int thid = KTH_current_thread; \
    stackp += toppred->arity + 1; \
    stackp[-1] = (q)toppred; \
    allocp[1] = makeint(thid); \
    allocp += 1; \
    KTH_thread_table[thid].stackp = stackp; \
    if (stackp > slimit) KTH_extend_stack(); \
    stackp = (q*)0; \
    allocp = interrupt_goal(allocp, &KTH_continue_thread_pred, reasonp); \
}

#define KTH_loop_within_module(f) \
{ \
    module (*func)(); \
    if (allocp >= heaplimit) {\
       if (stackp != (q*)0) {\
	  int thid = KTH_current_thread; \
	  allocp[0] = (q)qp; \
	  allocp[1] = (q)(&KTH_continue_thread_pred); \
	  allocp[2] = makeint(thid); \
	  qp = (struct goalrec*)&allocp[0]; \
	  allocp += 3; \
	  KTH_thread_table[thid].stackp = stackp; \
	  stackp = (q*)0; \
       } \
       allocp = klic_interrupt(allocp, qp); \
       qp = current_queue; \
    } \
    if (stackp != (q*)0) {\
       toppred = (struct predicate*)stackp[-1]; \
       if ((func = toppred->func) == (f)) goto module_top; \
    } \
    else { \
	func = qp->pred->func; \
    } \
    heapp = allocp; \
    current_queue = qp; \
    KTH_current_stackp = stackp; \
    return (module)(func); \
}
